# -*- coding: Shift-JIS -*-
import clr
import CommandPlugin
from CommandPlugin import WinAPI

clr.AddReferenceByPartialName("System")
clr.AddReferenceByPartialName("System.Windows.Forms")
clr.AddReferenceByPartialName("System.Drawing")
import System.Windows.Forms
from System.Windows.Forms import *
# Form, TextBox, Keys, DockStyle, BorderStyle, FormBorderStyle, FormStartPosition
from System.Drawing import *
# Color, Size, Font, FontStyle

class InputForm(Form):
  def __init__(self):
    Form.__init__(self)
    self.Text = "Svitch̓EBhE"
    self.TopMost = True
    self.KeyPreview = True
    self.FormBorderStyle = FormBorderStyle.FixedToolWindow

    # ̃L[ꂽƂɒm点R[obN֐
    self._keydown = None 
    self._keyup = None
    self._keypress = None

    self.text_box = HelpTextBox()
    self.text_box.onkeydown = self.TextBoxKeyDown
    self.SetHelp("R}hւ̓͑҂")
    self.StartPosition = FormStartPosition.CenterScreen
    self.Controls.Add(self.text_box)

  def SetHelp(self, text):
    self.text_box.Text = text
    width = self.PreferredSize.Width + self.text_box.PreferredSize.Width
    height = self.PreferredSize.Height + self.text_box.PreferredSize.Height
    self.Size = Size(width, height)

  def __HideTextBoxCaret(self):
    """ eLXg{bNX̃Lbg """
    WinAPI.HideCaret(self.text_box.Handle)
    self.text_box.SelectionLength = 0

  # override
  def OnActivated(self, event):
    """ ̓EBhEANeBuɂȂxɌĂяo """
    self.__HideTextBoxCaret()

  # override
  def OnDeactivate(self, event):
    """ ̓EBhEANeBuɂȂƂɌĂяo """
    self.Close()

  # override
  def OnShown(self, event):
    """ ŏɕ\񂾂Ăяo """
    self.__HideTextBoxCaret()
  
  def TextBoxKeyDown(self, event):
    # ESCL[Ctrl+[ꂽEBhE
    if event.KeyCode == Keys.Escape or event.KeyData == (Keys.Control | Keys.OemOpenBrackets):
      self.Close()
    func = self._keydown
    if callable(func):
      func(event)

  # override
  def OnKeyUp(self, event):
    func = self._keyup
    if callable(func):
      func(event)

  # override
  def OnKeyPress(self, event):
    func = self._keypress
    if callable(func):
      func(event)

class HelpTextBox(TextBox):
  def __init__(self):
    self.Font = Font("lr SVbN", 10.5)
    self.ReadOnly = True
    self.Multiline = True
    self.ForeColor = Color.Black
    self.BackColor = Color.White
    self.Dock = DockStyle.Fill
    self.BorderStyle = BorderStyle.None
    self.ShortcutsEnabled = False
    self.AcceptsReturn = False
    self.ImeMode = ImeMode.Disable

    self.onkeydown = None

  # override
  def OnPreviewKeyDown(self, event):
    if callable(self.onkeydown):
      self.onkeydown(event)

