# -*- coding: Shift-JIS -*-
import clr
import CommandPlugin
from CommandPlugin import WinAPI

clr.AddReferenceByPartialName("System.Windows.Forms")

from System.Windows.Forms import MessageBox

class State(object):
  NORMAL = 1
  MIN = 2
  MAX = 3

class RestoreWindow(object):
  """ EBhËʒuƃTCYLČɖ߂悤ɂ """

  def __init__(self):
    self.target_windows = []
    self.window_states = []
    self.window_rects = []

  def add(self, hwnd):
    """ ɖ߂ԂɂEBhEǉ """
    self.target_windows.append(hwnd)
    self.window_states.append(self.get_state(hwnd))
    self.window_rects.append(self.get_rect(hwnd))

  def get_state(self, hwnd):
    """ EBhȄԁiʏCŏCő剻j擾 """
    state = State.NORMAL
    if WinAPI.IsIconic(hwnd):
      state = State.MIN
    elif WinAPI.IsZoomed(hwnd):
       state = State.MAX 
    return state

  def get_rect(self, hwnd):
    """ EBhËʒuƃTCY擾 """
    return WinAPI.GetWindowRect(hwnd)

  def restore(self):
    """ o^ĂEBhEׂČɖ߂ """
    windows = self.target_windows
    states = self.window_states
    rects = self.window_rects
    for hwnd, state, rect in zip(windows, states, rects):
      left = rect.Left
      top = rect.Top
      width = rect.Width
      height = rect.Height
      if state == State.NORMAL:
        WinAPI.ShowNormalWindow(hwnd)
        WinAPI.MoveWindow(hwnd, left, top, width, height)
      elif state == State.MAX:
        WinAPI.MaximizeWindow(hwnd)
      elif state == State.MIN:
        WinAPI.MinimizeWindow(hwnd)
    self.target_windows = []
    self.window_states = []
    self.window_rects = []

