# -*- coding: Shift-JIS -*-
import clr
import CommandPlugin
from CommandPlugin import *

clr.AddReferenceByPartialName("System")
from System import IntPtr
clr.AddReferenceByPartialName("System.Windows.Forms")
from System.Windows.Forms import MessageBox, Keys, Screen

from lib.restore_window import RestoreWindow
from lib.input_form import InputForm
from lib.win_rect import WinRect

class move_win(CommandPlugin.PythonCommand):
  # xɈړ鋗@PʁFsNZ
  MOVE_UNIT = 50 

  def __init__(self):
    self.restore_win = RestoreWindow()
    self.win_rect = None
    self.taskbar = None
    self.input_form = None
 
  def run(self, info, arg_list):
    # argumentŎw肵ftHg͖̈
    arg_list.RemoveAt(0)
    
    self.taskbar = info.taskbar

    if len(arg_list) == 0:
      # Ȃꍇ͍őOʂ̃EBhEړɌ
      hwnd = info.last_fore_window
      if hwnd != IntPtr(0):
      	if not WinAPI.IsIconic(hwnd):
          self.restore_win.add(hwnd)
          self.win_rect = WinRect(hwnd)
          self.show_form()
    else:
      # ꍇ̓qg̕ƈvEBhEړΏۂɌ
      for arg in arg_list:
        index = info.hint_list.IndexOf(arg.ToUpper())
        if index != -1:
          win = info.window_list[index]
          self.restore_win.add(win.hwnd)
          self.win_rect = WinRect(win.hwnd)
          self.show_form()
          break
  
  def undo(self):
    self.restore_win.restore()
    return True
  
  def show_form(self):
    self.input_form = InputForm()
    self.input_form._keydown = self.key_down
    help_text = "yL[͂ŃEBhEړ܂z\r\n" + \
                "ControlL[ƃTCY܂\r\n" + \
                "             Shift + K\r\n" + \
                "                 K\r\n" + \
                "Shift + H   H       L   Shift + L\r\n" + \
                "                 J\r\n" + \
                "             Shift + J"
    self.input_form.SetHelp(help_text)
    self.input_form.Show()
  
  def key_down(self, event):
    """ L[͂ƂɌĂяo """
    rect = self.taskbar.GetShellTrayRect()
    # ivC}jfBXvC̃TCY
    disp_height = Screen.PrimaryScreen.Bounds.Height
    disp_width = Screen.PrimaryScreen.Bounds.Width
    screen_size = (disp_width, disp_height)

    left_margin = 0
    right_margin = 0
    top_margin = 0
    bottom_margin = 0
    if self.taskbar.IsTop():
      top_margin = rect.Height
    elif self.taskbar.IsRight():
      right_margin = rect.Width
    elif self.taskbar.IsBottom():
      bottom_margin = rect.Height
    elif self.taskbar.IsLeft():
      left_margin = rect.Width

    #self.input_form.SetHelp(event.KeyData.ToString())
    if event.KeyCode == Keys.Enter:
      self.input_form.Close()

    if event.Control:
      self.resize(event, screen_size,
          left_margin, top_margin, bottom_margin, right_margin)
    else:
      self.move(event, screen_size,
          left_margin, top_margin, bottom_margin, right_margin)
  
  def resize(self, event, screen_size, left_margin, top_margin, bottom_margin, right_margin):
    if event.KeyCode == Keys.H:
      self.win_rect.width -= self.MOVE_UNIT
    elif event.KeyCode == Keys.L:
      self.win_rect.width += self.MOVE_UNIT
    elif event.KeyCode == Keys.J:
      self.win_rect.height += self.MOVE_UNIT
    elif event.KeyCode == Keys.K:
      self.win_rect.height -= self.MOVE_UNIT

  def move(self, event, screen_size, left_margin, top_margin, bottom_margin, right_margin):
    # KeyCodeAlt, Control, ShiftL[\
    # KeyData͂̏CL[KeyCodȇgݍ킹\
    if event.KeyCode == Keys.H:
      # Ɉړ
      if event.Shift:
        self.win_rect.left = left_margin
      else:
        self.win_rect.left -= self.MOVE_UNIT
    elif event.KeyCode == Keys.L:
      # EɈړ
      if event.Shift:
        self.win_rect.right = screen_size[0] - right_margin
      else:
        self.win_rect.right += self.MOVE_UNIT
    elif event.KeyCode == Keys.J:
      # Ɉړ
      if event.Shift:
        self.win_rect.bottom = screen_size[1] - bottom_margin
      else:
        self.win_rect.bottom += self.MOVE_UNIT
    elif event.KeyCode == Keys.K:
      # Ɉړ
      if event.Shift:
        self.win_rect.top = top_margin
      else:
        self.win_rect.top -= self.MOVE_UNIT


